// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2018-05-24T09:03:17, by ESR Version 1.74.0.0 using ESR Database SWS_EA_ESR_Cloud_Prod
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using Ato.EN.IntegrationServices.Document.DataContracts;
using System.Text.RegularExpressions;

namespace Ato.EN.IntegrationServices.CodeGenerationDDADDRequest2018
{

    public partial class DDAdd2018Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// Initializes a new instance of the <see cref="DDAdd2018Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public DDAdd2018Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(string val)
        {
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmpty(decimal? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(int? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

         /// <summary>
         /// Get string value between [first] a and [last] b.
         /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

         /// <summary>
         /// Get string value after [first] a.
         /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

         /// <summary>
         /// Get string value after [last] a.
         /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
            return 0;
            else
            return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return ((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
           if (nodes == null)
                return false;

            nodes = nodes.Where(x => x != null).ToArray();
            return !((from x in nodes select x).Distinct().Count() == nodes.Count());
        
        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }
				//The logic in After function expects "---" for day and "--" for month. 
				//Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
					return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }

        private static DateTime? AddMonthsToDate(DateTime? dateTime, int months)
        {
            return dateTime == null ? null : (DateTime?)dateTime.Value.AddMonths(months);
        }

        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response = true;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length == 14)
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 3), out numeric))
                        response = false;

                }
                else if (usi.Length == 9)
                {

                    if (Regex.IsMatch(usi, @"^([a-zA-Z]{3}\d{4}[a-zA-Z]{2})$"))
                        response = false;
                }
            }
            return response;
        }

        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
             return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
             decimal numberValue;
             decimal.TryParse(value, out numberValue);
             return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':                        
                        options = options | RegexOptions.IgnoreCase;                       
                        break;
                    case 'm':                        
                        options = options | RegexOptions.Multiline;                       
                        break;
                    case 's':                        
                            options = options | RegexOptions.Singleline;                       
                        break;
                    case 'n':                        
                            options = options | RegexOptions.ExplicitCapture;                       
                        break;
                    case 'x':                       
                            options = options | RegexOptions.IgnorePatternWhitespace;                       
                        break;
                }
            }

            return options;
        }

        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public DDAdd2018 ConsumedReport { get; private set; }

        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string,ProcessMessageDocument>();

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(DDAdd2018 report)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            this.ConsumedReport = report;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------

    
            #region VR.ATO.DD.000001
    
            /*  VR.ATO.DD.000001
            The Australian Business Number (ABN) of the Registered agent must pass the ABN algorithm check.
    
            Legacy Rule Format:
            (^DD01 <> NULL) AND (FailsABNAlgorithm(^DD01))

            Technical Business Rule Format:
            (^DD01 <> NULL) AND (FailsABNAlgorithm(^DD01))
    
            Data Elements:
    
            ^DD01 = DDAdd:INT:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.DD01 != null && FailsABNAlgorithm(report.DD01));
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000001", Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered agent ABN is invalid.",
                    Location = "/tns:DDAdd/tns:INT/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000001"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD01", Value = report.DD01 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000001
    
            #region VR.ATO.DD.000002
    
            /*  VR.ATO.DD.000002
            The Registered Agent Number (RAN) must pass the Tax Agent Number (TAN) algorithm check.
    
            Legacy Rule Format:
            (^DD02 <> NULL) AND (((Length(^DD02) =7) AND (FailsTANAlgorithm(Concat('0', ^DD02)))) OR ((Length(^DD02) =8) AND (FailsTANAlgorithm(^DD02))))

            Technical Business Rule Format:
            (^DD02 <> NULL) AND (((Length(^DD02) =7) AND (FailsTANAlgorithm(Concat('0', ^DD02)))) OR ((Length(^DD02) =8) AND (FailsTANAlgorithm(^DD02))))
    
            Data Elements:
    
            ^DD02 = DDAdd:INT:Identifiers.TaxAgentNumber.Identifier
            */
            assertion = (report.DD02 != null && (Length(report.DD02) == 7 && FailsTANAlgorithm(string.Concat(@"0", report.DD02)) || Length(report.DD02) == 8 && FailsTANAlgorithm(report.DD02)));
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000002", Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered agent RAN is invalid.",
                    Location = "/tns:DDAdd/tns:INT/tns:TaxAgentNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000002"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD02", Value = GetValueOrEmpty(report.DD02) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000002
    
            #region VR.ATO.DD.000003
    
            /*  VR.ATO.DD.000003
            The Tax File Number (TFN) of the Client must pass the TFN algorithm check.
    
            Legacy Rule Format:
            (^DD03 <> NULL) AND (FailsTFNAlgorithm(^DD03))

            Technical Business Rule Format:
            (^DD03 <> NULL) AND (FailsTFNAlgorithm(^DD03))
    
            Data Elements:
    
            ^DD03 = DDAdd:RP:Identifiers.TaxFileNumber.Identifier
            */
            assertion = (report.DD03 != null && FailsTFNAlgorithm(report.DD03));
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000003", Severity = ProcessMessageSeverity.Error,
                    Description = @"Client TFN is invalid.",
                    Location = "/tns:DDAdd/tns:RP/tns:TaxFileNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000003"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD03", Value = GetValueOrEmpty(report.DD03) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000003
    
            #region VR.ATO.DD.000004
    
            /*  VR.ATO.DD.000004
            The Australian Business Number (ABN) of the Client must pass the ABN algorithm check.
    
            Legacy Rule Format:
            (^DD04 <> NULL) AND (FailsABNAlgorithm(^DD04))

            Technical Business Rule Format:
            (^DD04 <> NULL) AND (FailsABNAlgorithm(^DD04))
    
            Data Elements:
    
            ^DD04 = DDAdd:RP:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.DD04 != null && FailsABNAlgorithm(report.DD04));
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000004", Severity = ProcessMessageSeverity.Error,
                    Description = @"Client ABN is invalid.",
                    Location = "/tns:DDAdd/tns:RP/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000004"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD04", Value = GetValueOrEmpty(report.DD04) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000004
    
            #region VR.ATO.DD.000005
    
            /*  VR.ATO.DD.000005
            The Withholding Payer Number (WPN) of the Client must pass the WPN algorithm check.
    
            Legacy Rule Format:
            (^DD05 <> NULL) AND (FailsWPNAlgorithm(^DD05))

            Technical Business Rule Format:
            (^DD05 <> NULL) AND (FailsWPNAlgorithm(^DD05))
    
            Data Elements:
    
            ^DD05 = DDAdd:RP:Identifiers.WithholdingPayerNumber.Identifier
            */
            assertion = (report.DD05 != null && FailsTFNAlgorithm(report.DD05));
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000005", Severity = ProcessMessageSeverity.Error,
                    Description = @"Client WPN is invalid.",
                    Location = "/tns:DDAdd/tns:RP/tns:WithholdingPayerNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000005"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD05", Value = GetValueOrEmpty(report.DD05) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000005
    
            #region VR.ATO.DD.000006
    
            /*  VR.ATO.DD.000006
            At least one of Account identifier and Account sequence number must be supplied.
    
            Legacy Rule Format:
            (^DD07 = NULL) AND (^DD08 = NULL)

            Technical Business Rule Format:
            (^DD07 = NULL) AND (^DD08 = NULL)
    
            Data Elements:
    
            ^DD07 = DDAdd:RP:AccountDetails:Tax.Account.Identifier
    
            ^DD08 = DDAdd:RP:AccountDetails:Tax.AccountSequence.Number
            */
            assertion = (report.DD07 == null && report.DD08 == null);
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000006", Severity = ProcessMessageSeverity.Error,
                    Description = @"Account identifier and Account sequence number not provided.",
                    Location = "/tns:DDAdd/tns:RP/tns:AccountDetails/tns:TaxId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000006"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD07", Value = GetValueOrEmpty(report.DD07) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD08", Value = report.DD08.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000006
    
            #region VR.ATO.DD.000007
    
            /*  VR.ATO.DD.000007
            If provided, Intermediary Signature Indicator must be 'TRUE'
    
            Legacy Rule Format:
            (^DD306 <> NULL) AND (^DD19 <> TRUE)

            Technical Business Rule Format:
            (^DD306 <> NULL) AND (^DD19 <> TRUE)
    
            Data Elements:
    
            ^DD19 = DDAdd:INT:INTDeclaration:Declaration.StatementAccepted.Indicator
    
            ^DD306 = DDAdd:INT:INTDeclaration
            */
            assertion = (report.InT_INTDeclarationCollectionExists != false && report.DD19 != true);
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000007", Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration signature indicator must be true.",
                    Location = "/tns:DDAdd/tns:INT/tns:INTDeclaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000007"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD19", Value = GetValueOrEmpty(report.DD19) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000007
    
            #region VR.ATO.DD.000008
    
            /*  VR.ATO.DD.000008
            (The declaration must be provided by the sender.) If the sender is intermediary then the declaration must be provided by intermediary
    
            Legacy Rule Format:
            (^DD300 <> NULL) AND (^DD306 = NULL)

            Technical Business Rule Format:
            (^DD300 <> NULL) AND (^DD306 = NULL)
    
            Data Elements:
    
            ^DD300 = DDAdd:INT
    
            ^DD306 = DDAdd:INT:INTDeclaration
            */
            assertion = (report.IntCollectionExists != false && report.InT_INTDeclarationCollectionExists == false);
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000008", Severity = ProcessMessageSeverity.Error,
                    Description = @"The sender's Declaration is not provided.",
                    Location = "/tns:DDAdd/tns:INT/tns:INTDeclaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000008"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000008
    
            #region VR.ATO.DD.000009
    
            /*  VR.ATO.DD.000009
            If provided, Reporting Party Signature Indicator must be 'TRUE'
    
            Legacy Rule Format:
            (^DD307 <> NULL) AND (^DD21 <> TRUE)

            Technical Business Rule Format:
            (^DD307 <> NULL) AND (^DD21 <> TRUE)
    
            Data Elements:
    
            ^DD21 = DDAdd:RP:RPDeclaration:Declaration.StatementAccepted.Indicator
    
            ^DD307 = DDAdd:RP:RPDeclaration
            */
            assertion = (report.RP_RPDeclarationCollectionExists != false && report.DD21 != true);
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000009", Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration signature indicator must be true.",
                    Location = "/tns:DDAdd/tns:RP/tns:RPDeclaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000009"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD21", Value = GetValueOrEmpty(report.DD21) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000009
    
            #region VR.ATO.DD.000010
    
            /*  VR.ATO.DD.000010
            (The declaration must be provided by the sender.) If the sender is the Reporting Party then the declaration must be provided by Reporting Party
    
            Legacy Rule Format:
            (^DD300 = NULL) AND (^DD307 = NULL)

            Technical Business Rule Format:
            (^DD300 = NULL) AND (^DD307 = NULL)
    
            Data Elements:
    
            ^DD300 = DDAdd:INT
    
            ^DD307 = DDAdd:RP:RPDeclaration
            */
            assertion = (report.IntCollectionExists == false && report.RP_RPDeclarationCollectionExists == false);
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000010", Severity = ProcessMessageSeverity.Error,
                    Description = @"The sender's Declaration is not provided.",
                    Location = "/tns:DDAdd/tns:RP/tns:RPDeclaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000010"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000010
    
            #region VR.ATO.DD.000011
    
            /*  VR.ATO.DD.000011
            BSB must be between 012000 and 999999.
    
            Legacy Rule Format:
            (^DD15 <> NULL) AND (^DD15 < 012000 OR ^DD15 > 999999)

            Technical Business Rule Format:
            (^DD15 <> NULL) AND (^DD15 < 012000 OR ^DD15 > 999999)
    
            Data Elements:
    
            ^DD15 = DDAdd:RP:DirectDebitDetails:FinancialInstitutionAccount.BankStateBranch.Number
            */
            assertion = (report.DD15 != null && (AsNumeric(report.DD15) < 12000 || AsNumeric(report.DD15) > 999999));
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000011", Severity = ProcessMessageSeverity.Error,
                    Description = @"Bank State Branch number is invalid.",
                    Location = "/tns:DDAdd/tns:RP/tns:DirectDebitDetails/tns:FinancialInstitutionAccountBankStateBranchN",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000011"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD15", Value = report.DD15 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000011
    
            #region VR.ATO.DD.000012
    
            /*  VR.ATO.DD.000012
            Payment amount must be between $10.00 and $999,999.99.
    
            Legacy Rule Format:
            (^DD18 <> NULL) AND (^DD18 < 10 OR ^DD18 > 999999.99)

            Technical Business Rule Format:
            (^DD18 <> NULL) AND (^DD18 < 10 OR ^DD18 > 999999.99)
    
            Data Elements:
    
            ^DD18 = DDAdd:RP:DirectDebitDetails:PaymentRecord.Payment.Amount
            */
            assertion = (report.DD18 != null && (report.DD18.GetValueOrDefault() < 10 || report.DD18.GetValueOrDefault() > 999999.99M));
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000012", Severity = ProcessMessageSeverity.Error,
                    Description = @"Payment amount is invalid.",
                    Location = "/tns:DDAdd/tns:RP/tns:DirectDebitDetails/tns:PaymentRecordPaymentA",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000012"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD18", Value = GetValueOrEmpty(report.DD18) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000012
    
            #region VR.ATO.DD.000013
    
            /*  VR.ATO.DD.000013
            The Role type provided can only be 'PAYGW'.
    
            Legacy Rule Format:
            (^DD09 <> NULL) AND (^DD09 <> 'PAYGW')

            Technical Business Rule Format:
            (^DD09 <> NULL) AND (^DD09 <> 'PAYGW')
    
            Data Elements:
    
            ^DD09 = DDAdd:RP:AccountDetails:Tax.RoleType.Code
            */
            assertion = (report.DD09 != null && report.DD09 != @"PAYGW");
            if (assertion)
            {
                // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DD.000013", Severity = ProcessMessageSeverity.Error,
                    Description = @"Role type provided is invalid.",
                    Location = "/tns:DDAdd/tns:RP/tns:AccountDetails/tns:TaxRoleTypeC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.DD.000013"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "DD09", Value = GetValueOrEmpty(report.DD09) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.DD.000013

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }


    }
} 
